import { Writable } from 'svelte/store';

interface Serializer<T> {
    parse(text: string): T;
    stringify(object: T): string;
}
interface Options<T> {
    serializer: Serializer<T>;
}
declare function writable<T>(key: string, initialValue: T, options?: Options<T>): Writable<T>;

export { writable };
